; NOTE:
; Previous my testings I complete with NOT-CASE-TOLERANT Lingo's proc.
; In this test, I use new Lingo's proc, which is case tolerant, as my (Alex's - Axhex2dw)
; So, please, test it, and say me timings.
; You may change the string length, or its case, and see results and timings also.
;
; And, if I don't bothered to you, comment next macro, and test also:
UseFastestVariant EQU 1
; If this macro is defined, used more speedy and slightly longer Axhex2dw proc,
; if macro is not defined, used shortes and slightly slower proc.

.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			
LOOP_COUNT	= 100000

l_htodw	PROTO :DWORD
l_htodwJJ	PROTO :DWORD
l_a2l	PROTO :DWORD
Axhex2dw	PROTO :DWORD
Axa2l	PROTO :DWORD
z_htodw	PROTO :DWORD
Axhex2dwJJ	PROTO :DWORD
krbhtodw	PROTO :DWORD

.data
cbTable	BYTE 48 DUP (0FFh)
	BYTE 0,1,2,3,4,5,6,7,8,9
	BYTE 7 DUP (0FFh)
	BYTE 10,11,12,13,14,15
	BYTE 26 DUP (0FFh)
	BYTE 10,11,12,13,14,15
	BYTE 29 DUP (0FFh)
	BYTE 128 DUP (0FFh)

align 16
tabl1  dd   0,1,2,3,4,5,6,7,8,9
		  dd 	  39 Dup(0)
          dd   0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh

align 16
; hexstring	db "00000000",0
hexstring	db "abCDef01",0
; hexstring	db "0BCDEF00",0

;align 16
;numstring db "1234543210",0
;align 16
;negnumstring db "-1234543210",0

.code
start:
	if 1	; test for correct results, OK
		invoke l_htodwJJ, addr  hexstring
		print str$(eax), 9, "result l_htodwJJ - improved by JJ", 13, 10
		invoke l_htodw, addr  hexstring
		print str$(eax), 9, "result l_htodw", 13, 10
		invoke Axhex2dw, addr  hexstring
		print str$(eax), 9, "result Axhex2dw", 13, 10
		invoke z_htodw, addr  hexstring
		print str$(eax), 9, "result z_htodw", 13, 10
		invoke Axhex2dwJJ, addr  hexstring
		print str$(eax), 9, "result Axhex2dwJJ", 13, 10
		invoke krbhtodw, addr  hexstring
		print str$(eax), 9, "result krbhtodw", 13, 10
	endif

	invoke GetCurrentThread
	invoke SetThreadAffinityMask,eax,1
	invoke Sleep,0
	
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	
	print "Test with case-insensitive variant of Lingo's hex2dword algo",13,10
	print "with using simple string in .data section (not in the end of the buffer).",13,10,13,10

	REPEAT 3
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke l_htodwJJ, addr  hexstring
	counter_end
	print str$(eax), 9, "cycles for  l_htodwJJ - Lingo improved by JJ", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke l_htodw, addr  hexstring
	counter_end
	print str$(eax), 9, "cycles for  l_htodw - Lingo", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw, addr  hexstring
	counter_end
	print str$(eax), 9, "cycles for  Axhex2dw - Alex", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke z_htodw, addr  hexstring
	counter_end
	print str$(eax), 9, "cycles for  z_htodw - Clive", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dwJJ, addr  hexstring
	counter_end
	print str$(eax), 9, "cycles for  Axhex2dwJJ - Alex+JJ", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke krbhtodw, addr  hexstring
	counter_end
	print str$(eax), 9, "cycles for  krbhtodw - Dave", 13, 10, 10

	ENDM
	
	;invoke z_htodw, addr  hexstring
	;print str$(eax)," : cliveret",13,10,13,10

	print " ", 13, 10
	print "Codesizes:", 13, 10
	print "l_htodw - Lingo:", 9
	mov   eax, l_htodw_endp
	sub	  eax, l_htodw
	print str$(eax), 13, 10

	print "l_htodw - Lingo improved by JJ:", 9
	mov   eax, l_htodwJJ_endp
	sub	  eax, l_htodwJJ
	print str$(eax), 13, 10
	print "Axhex2dw - Alex:", 9
	mov   eax, Axhex2dw_endp
	sub	  eax, Axhex2dw_s
	print str$(eax), 13, 10

	print "z_htodw - Clive:", 9
	mov   eax, z_htodw_endp
	sub	  eax, z_htodw
	print str$(eax), 13, 10

	print "Axhex2dw - Ax+JJ:", 9
	mov   eax, Axhex2dwJJ_endp
	sub	  eax, Axhex2dwJJ_s
	print str$(eax), 13, 10

	print "krbhtodw - Dave:", 9
	mov   eax, krbhtodw_endp
	sub	  eax, krbhtodw_s
	print str$(eax), 13, 10

	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

option prologue:none
option epilogue:none

align 16
db 0,0,0,0,0,0,0,0
l_htodwJJ   proc lpString:dword
	mov		edx, [esp+4]
	push esi
	push ebx
	mov ebx, 11011111Y
	mov esi, offset tabl1-40h
	mov		eax, 1001111Y
	and      eax, [edx]
	mov		ecx, ebx 
	jz			@f
	mov		eax, [esi+eax*4]
	and      ecx, [edx+1]
	jz			@f
	shl	    eax, 4
	add		eax, [esi+ecx*4]
	mov		ecx, ebx 
	and      ecx,[edx+2]
	jz			@f
	shl	    eax, 4
	add		eax, [esi+ecx*4]
	mov		ecx, ebx 
	and      ecx,[edx+3]
	jz			@f
	shl	    eax, 4
	add		eax, [esi+ecx*4]
	mov		ecx, ebx 
	and      ecx,[edx+4]
	jz			@f
	shl	    eax, 4
	add		eax, [esi+ecx*4]
	mov		ecx, ebx 
	and      ecx,[edx+5]
	jz			@f
	shl	    eax, 4
	add		eax, [esi+ecx*4]
	mov		ecx, ebx 
	and      ecx,[edx+6]
	jz			@f
	shl	    eax, 4
	add		eax, [esi+ecx*4]
	mov		ecx, ebx 
	and      ecx,[edx+7]
	jz			@f
	shl	    eax, 4
	add		eax, [esi+ecx*4]
@@:
	pop ebx
	pop esi
	ret		4
l_htodwJJ  endp
l_htodwJJ_endp:

align 16
db 0,0,0,0,0,0,0,0
l_htodw   proc lpString:dword
	mov		edx, [esp+4]
	mov		eax, 1101111Y
	and      eax, [edx]
	mov		ecx, 11011111Y 
	jz			@f
	mov		eax, [tabl1+eax*4-40h]
	and      ecx, [edx+1]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+2]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+3]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+4]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+5]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+6]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+7]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
@@:
	ret		4
l_htodw  endp
l_htodw_endp:

align 16			; code size counts from behind this instruction
Axhex2dw_s:
	;#############################################################	
ifndef UseFastestVariant
	; If macro defined, then:
	; align proc to 4 bytes, and main loop of proc to 16 bytes
	db 0CCh,0CCh,0CCh,0CCh ; shifting to align main loop at 16 bytes
endif
Axhex2dw    proc STDCALL lpszStr:DWORD
	;int 3

	;#############################################################	
ifndef UseFastestVariant

	; If macro defined, then:
	; Using simple and standard methodic to getting argument,
	; and shorter form of code: zero eax via "xor" and preprocess first
	; pass via jumping to start of next pass

	mov edx,[esp+4]
	xor eax,eax
	mov [esp+4],edi
	
	jmp @preloop
	
else	;#############################################################

	; If macro NOT defined, then:
	; Using "witch-doctor's" methodics with long form of instructions
	; And code is slightly longer, but, on my PC, faster.
	
	;binary code of
	;mov edx,[esp+(DWORD)4]
	;db 8bh,94h,24h,4,0,0,0
	
	mov edx,[esp+4]
	
	mov eax,0
	
	;binary code of
	;mov [esp+(DWORD)4],edi
	db 89h,0bch,24h,4,0,0,0
	
	;binary code of
	;movzx ecx,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,4Ah,0
	
	;binary code of
	;movzx edi,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,7Ah,0
	
	;test ecx,ecx
	;binary code of
	;cmp ecx,(DWORD)0
	db 81h,0F9h,0,0,0,0
	
	
	jz @done
	;and edi,1111Y
endif
	;#############################################################
	
	; main loop
	@@:	; loop aligned by 16 bytes
	and edi,1111Y
	shr ecx,6
	shl eax,4
	lea ecx,[ecx+ecx*8]
	add edx,1
	lea edi,[edi+ecx]
	add eax,edi
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx edi,byte ptr [edx]
	cmp ecx,0
	jnz @B
	
	@done:
	mov edi,[esp+4]
	ret 4
Axhex2dw    endp
Axhex2dw_endp:

align 16
db 0
z_htodw   proc lpString:dword
mov edx, [esp+4]
        movzx   ecx, byte ptr [edx]
        xor     eax, eax
and     ecx, -021h
        je      @2
push    ebx
@1:
        add     edx, 1
shl     eax, 4
add     ecx, -040h
        lea     ebx, [ecx+027h]
cmovb   ebx, ecx
movzx   ecx, byte ptr [edx]
lea     eax, [eax+ebx+9]
        and     ecx, -021h
        jnz     @1
        pop     ebx
@2:
        ret 4
z_htodw  endp
z_htodw_endp:

align 16			; code size counts from behind this instruction
Axhex2dwJJ_s:
REPEAT 0
	INT 3
ENDM
Axhex2dwJJ    proc lpszStr:DWORD
	mov edx, [esp+4]
	if 1
		movzx ecx, byte ptr [edx]
		push edi
		xor eax, eax
		mov edi, ecx
	else
		push edi
		xor eax, eax
		movzx ecx, byte ptr [edx]
		movzx edi, byte ptr [edx]
	endif
	if 1
		jecxz @done
	else
		test ecx, ecx
		jz @done
	endif
	
@@:	and edi, 1111Y
	shr ecx, 6		; ecx/64
	inc edx
	if 1
		lea edi, [edi+8*ecx]
	else
		lea ecx, [ecx+ecx*8]		; ecx*9
	endif
	add eax, eax
	add edi, ecx
	lea eax, [8*eax+edi]			; faster
	if 1
		movzx ecx, byte ptr [edx]		; strangely enough,
		movzx edi, byte ptr [edx]		; this is faster
	else
		movzx ecx, byte ptr [edx]
		mov edi, ecx
	endif
	test ecx, ecx
	jnz @B
	
	@done:
	pop edi
	ret 4
Axhex2dwJJ    endp
Axhex2dwJJ_endp:

align 16
krbhtodw_s:
krbhtodw PROC lpString:DWORD
	mov edx,[esp+4]
	xor eax,eax
	mov ecx,OFFSET cbTable
	push ebx
	Increment TEXTEQU %(0)
	mov cl,BYTE PTR [edx+Increment]
	movzx ebx,BYTE PTR [ecx]
	or bl,bl
	js Exit

	REPEAT 7
		Increment TEXTEQU %(Increment+1)
		shl eax,4
		mov cl,BYTE PTR [edx+Increment]
		lea eax,[eax+ebx]
		movzx ebx,BYTE PTR [ecx]
		or bl,bl
		js Exit
	ENDM

	shl eax,4
	lea eax,[eax+ebx]
Exit:
	pop ebx
	ret 4
krbhtodw ENDP
krbhtodw_endp:

option prologue:prologuedef
option epilogue:epiloguedef

end start

OPT_Tmp2Asm	1
OPT_Res	0
